"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyDocWrite = exports.applyFieldWrite = exports.ApplyDocWriteError = void 0;
const trimop_1 = require("trimop");
const data_1 = require("./data");
function ApplyDocWriteError(p) {
    return Object.assign({}, p);
}
exports.ApplyDocWriteError = ApplyDocWriteError;
/**
 *
 * @param param0
 * @returns
 */
function applyFieldWrite({ field, writeField, }) {
    if (writeField._type === 'String') {
        if (field === undefined || field._type === 'String') {
            return trimop_1.Right(writeField);
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['String', 'undefined'],
            field,
        }));
    }
    if (writeField._type === 'Number') {
        if (field === undefined || field._type === 'Number') {
            return trimop_1.Right(writeField);
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['Number', 'undefined'],
            field,
        }));
    }
    if (writeField._type === 'Image') {
        if (field === undefined || field._type === 'Image') {
            return trimop_1.Right(writeField);
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['Image', 'undefined'],
            field,
        }));
    }
    if (writeField._type === 'Date') {
        if (field === undefined || field._type === 'Date') {
            return trimop_1.Right(writeField);
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['Date', 'undefined'],
            field,
        }));
    }
    if (writeField._type === 'Ref') {
        if (field === undefined || field._type === 'Ref') {
            return trimop_1.Right(writeField);
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['Ref', 'undefined'],
            field,
        }));
    }
    if (writeField._type === 'CreationTime') {
        if (field === undefined) {
            return trimop_1.Right(data_1.DateField(new Date()));
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['undefined'],
            field,
        }));
    }
    if (writeField._type === 'Increment') {
        if (field === undefined || field._type === 'Number') {
            return trimop_1.Right(data_1.NumberField((field !== undefined ? field.value : 0) + writeField.value));
        }
        return trimop_1.Left(ApplyDocWriteError({
            expectedFieldTypes: ['Number', 'undefined'],
            field,
        }));
    }
    // writeField._type === 'RefUpdate'
    if ((field === null || field === void 0 ? void 0 : field._type) === 'Ref') {
        return trimop_1.eitherMapRight(
        // eslint-disable-next-line no-use-before-define
        applyDocWrite({ doc: field.snapshot.doc, writeDoc: writeField.doc }), (newDoc) => trimop_1.Right(data_1.RefField({
            doc: newDoc,
            id: field.snapshot.id,
        })));
    }
    return trimop_1.Left(ApplyDocWriteError({
        expectedFieldTypes: ['Ref'],
        field,
    }));
}
exports.applyFieldWrite = applyFieldWrite;
function applyDocWrite({ doc, writeDoc, }) {
    return Object.entries(writeDoc).reduce((acc, [fieldName, writeField]) => trimop_1.eitherMapRight(acc, (acc) => trimop_1.eitherMapRight(applyFieldWrite({ field: doc === null || doc === void 0 ? void 0 : doc[fieldName], writeField }), (field) => trimop_1.Right(Object.assign(Object.assign({}, acc), { [fieldName]: field })))), trimop_1.Right(doc !== null && doc !== void 0 ? doc : {}));
}
exports.applyDocWrite = applyDocWrite;
//# sourceMappingURL=apply-doc-write.js.map