var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { eitherMapRight, Left, Right } from 'trimop';
import { DateField, NumberField, RefField } from './data';
export function ApplyDocWriteError(p) {
    return __assign({}, p);
}
/**
 *
 * @param param0
 * @returns
 */
export function applyFieldWrite(_a) {
    var field = _a.field, writeField = _a.writeField;
    if (writeField._type === 'String') {
        if (field === undefined || field._type === 'String') {
            return Right(writeField);
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['String', 'undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'Number') {
        if (field === undefined || field._type === 'Number') {
            return Right(writeField);
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['Number', 'undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'Image') {
        if (field === undefined || field._type === 'Image') {
            return Right(writeField);
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['Image', 'undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'Date') {
        if (field === undefined || field._type === 'Date') {
            return Right(writeField);
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['Date', 'undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'Ref') {
        if (field === undefined || field._type === 'Ref') {
            return Right(writeField);
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['Ref', 'undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'CreationTime') {
        if (field === undefined) {
            return Right(DateField(new Date()));
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['undefined'],
            field: field,
        }));
    }
    if (writeField._type === 'Increment') {
        if (field === undefined || field._type === 'Number') {
            return Right(NumberField((field !== undefined ? field.value : 0) + writeField.value));
        }
        return Left(ApplyDocWriteError({
            expectedFieldTypes: ['Number', 'undefined'],
            field: field,
        }));
    }
    // writeField._type === 'RefUpdate'
    if ((field === null || field === void 0 ? void 0 : field._type) === 'Ref') {
        return eitherMapRight(
        // eslint-disable-next-line no-use-before-define
        applyDocWrite({ doc: field.snapshot.doc, writeDoc: writeField.doc }), function (newDoc) {
            return Right(RefField({
                doc: newDoc,
                id: field.snapshot.id,
            }));
        });
    }
    return Left(ApplyDocWriteError({
        expectedFieldTypes: ['Ref'],
        field: field,
    }));
}
export function applyDocWrite(_a) {
    var doc = _a.doc, writeDoc = _a.writeDoc;
    return Object.entries(writeDoc).reduce(function (acc, _a) {
        var fieldName = _a[0], writeField = _a[1];
        return eitherMapRight(acc, function (acc) {
            return eitherMapRight(applyFieldWrite({ field: doc === null || doc === void 0 ? void 0 : doc[fieldName], writeField: writeField }), function (field) {
                var _a;
                return Right(__assign(__assign({}, acc), (_a = {}, _a[fieldName] = field, _a)));
            });
        });
    }, Right(doc !== null && doc !== void 0 ? doc : {}));
}
//# sourceMappingURL=apply-doc-write.js.map