import { Either } from 'trimop';
import { Doc, Field } from './data';
import { SyncedFields } from './spec';
/**
 * FilterSyncedFieldInvalidFieldTypeError
 */
export declare type FilterSyncedFieldsError = {
    readonly expectedFieldTypes: readonly (Field['_type'] | 'undefined')[];
    readonly field: Field | undefined;
};
export declare function FilterSyncedFieldsError(p: FilterSyncedFieldsError): FilterSyncedFieldsError;
/**
 * Filter synced fields.
 * @param doc to be filtered
 * @param syncedFields
 * @returns synced fields if exists, undefined otherwise.
 */
export declare function filterSyncedFields({ doc, syncedFields, }: {
    readonly doc: Doc;
    readonly syncedFields: SyncedFields;
}): Either<FilterSyncedFieldsError, Doc | undefined>;
//# sourceMappingURL=filter-synced-fields.d.ts.map